/*IN FISH AT EGOI I TRUST*/
/*IN FISH AT EGOI I TRUST*/
/*IN FISH AT EGOI I TRUST*/
#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef pair<ll,ll> pll;
typedef long double ld;

mt19937 gen(chrono::steady_clock::now().time_since_epoch().count());
#pragma GCC optimize("O3,unroll-loops")
#pragma GCC target("avx2,bmi,bmi2,popcnt")
ll mod,tt,v1,v2,d,n,g[2000009],bs;
vector<pll> A[2000009];
vector<ll> B;
unordered_map<ll,ll> mp;
ll f(ll x,ll y){
   return (ll)x*(2*n+1)+y;
}
ll p(ll x,ll y){
   x=f(x,y);
   if(mp.count(x)) return mp[x];
   else return 0;
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    mod=1e9+7;
    cin>>tt;
    while(tt--){
        cin>>n;
        bs=800;
        for(int i=1;i<=2*n;i++) g[i]=0;
        for(int i=1;i<=2*n;i++) A[i].clear();
        B.clear();
        mp.clear();
        for(int i=1;i<=n;i++) {
            cin>>v1>>v2>>d;
            g[v1]+=d;
            g[v2]+=d;
            if(v1>v2) swap(v1,v2);
            A[v1].push_back({v2,d});
            A[v2].push_back({v1,d});
            mp[f(v1,v2)]+=d;
        }
        ll res=0;
        for(int i=1;i<=2*n;i++) res=max(res,g[i]);

        for(int i=1;i<=2*n;i++) {
                if(A[i].size()<bs) {
                    sort(A[i].begin(),A[i].end());
                    for(int j=0;j<A[i].size();j++) for(int h=j+1;h<A[i].size();h++) {
                            res=max(res,A[i][j].second+A[i][h].second+p(A[i][j].first,A[i][h].first));
                    }
                }
                else B.push_back(i);
        }
        ll N=B.size();
        for(int a=0;a<N;a++) for(int b=a+1;b<N;b++) for(int c=b+1;c<N;c++) {
                res=max(res,p(a,b)+p(a,c)+p(b,c));
        }
        cout<<res<<"\n";


    }





    return 0;
}
